# Desc: A list of executables to be started every day at midnight.
# Usage: nfg_run_daily_jobs.sh arg1
# Input: arg1: path to directory containing ninfacyzga-1 repository
-# arg2:
-# Note: These jobs permit the general strategy of storing current instances of
-# observed data in a temporary directory that can be accessed as a file from
-# other scripts without each script having to know about eachother's
-# existence.
# Note: Run this script daily at midnight using `cron`.
-#==BEGIN Define script parameters==
nfg_base_dir="../";
nfg_exec_dir="$nfg_base_dir"/exec;
length_day_s=$((24 * 60 * 60)); # seconds
-#===BEGIN Define variables===
-declare -Ag appRollCall # Associative array for storing app status
-declare -Ag fileRollCall # Associative array for storing file status
-declare -Ag dirRollCall # Associative array for storing dir status
-#===END Define variables===
-#===BEGIN Declare local script functions===
yell() { echo "$0: $*" >&2; } # print script path and all args to stderr
die() { yell "$*"; exit 111; } # same as yell() but non-zero exit status
try() { "$@" || die "cannot $*"; } # runs args as command, reports args if command fails
-checkapp() {
- # Desc: If arg is a command, save result in assoc array 'appRollCall'
- # Usage: checkapp arg1 arg2 arg3 ...
- # Version: 0.1.1
- # Input: global assoc. array 'appRollCall'
- # Output: adds/updates key(value) to global assoc array 'appRollCall'
- # Depends: bash 5.0.3
- local returnState
- #===Process Args===
- for arg in "$@"; do
- if command -v "$arg" 1>/dev/null 2>&1; then # Check if arg is a valid command
- appRollCall[$arg]="true";
- if ! [ "$returnState" = "false" ]; then returnState="true"; fi;
- else
- appRollCall[$arg]="false"; returnState="false";
- fi;
- done;
+# Note: Use '&' to run scripts and immediately detach them.
- #===Determine function return code===
- if [ "$returnState" = "true" ]; then
- return 0;
- else
- return 1;
- fi;
-} # Check that app exists
-checkfile() {
- # Desc: If arg is a file path, save result in assoc array 'fileRollCall'
- # Usage: checkfile arg1 arg2 arg3 ...
- # Version: 0.1.1
- # Input: global assoc. array 'fileRollCall'
- # Output: adds/updates key(value) to global assoc array 'fileRollCall';
- # Output: returns 0 if app found, 1 otherwise
- # Depends: bash 5.0.3
- local returnState
+# Temperature
- #===Process Args===
- for arg in "$@"; do
- if [ -f "$arg" ]; then
- fileRollCall["$arg"]="true";
- if ! [ "$returnState" = "false" ]; then returnState="true"; fi;
- else
- fileRollCall["$arg"]="false"; returnState="false";
- fi;
- done;
-
- #===Determine function return code===
- if [ "$returnState" = "true" ]; then
- return 0;
- else
- return 1;
- fi;
-} # Check that file exists
-checkdir() {
- # Desc: If arg is a dir path, save result in assoc array 'dirRollCall'
- # Usage: checkdir arg1 arg2 arg3 ...
- # Version 0.1.1
- # Input: global assoc. array 'dirRollCall'
- # Output: adds/updates key(value) to global assoc array 'dirRollCall';
- # Output: returns 0 if app found, 1 otherwise
- # Depends: Bash 5.0.3
- local returnState
+# Pressure
- #===Process Args===
- for arg in "$@"; do
- if [ -d "$arg" ]; then
- dirRollCall["$arg"]="true";
- if ! [ "$returnState" = "false" ]; then returnState="true"; fi
- else
- dirRollCall["$arg"]="false"; returnState="false";
- fi
- done
-
- #===Determine function return code===
- if [ "$returnState" = "true" ]; then
- return 0;
- else
- return 1;
- fi
-} # Check that dir exists
-displayMissing() {
- # Desc: Displays missing apps, files, and dirs
- # Usage: displayMissing
- # Version 0.1.1
- # Input: associative arrays: appRollCall, fileRollCall, dirRollCall
- # Output: stderr: messages indicating missing apps, file, or dirs
- # Depends: bash 5, checkAppFileDir()
- local missingApps value appMissing missingFiles fileMissing
- local missingDirs dirMissing
-
- #==BEGIN Display errors==
- #===BEGIN Display Missing Apps===
- missingApps="Missing apps :";
- #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
- for key in "${!appRollCall[@]}"; do
- value="${appRollCall[$key]}";
- if [ "$value" = "false" ]; then
- #echo "DEBUG:Missing apps: $key => $value";
- missingApps="$missingApps""$key ";
- appMissing="true";
- fi;
- done;
- if [ "$appMissing" = "true" ]; then # Only indicate if an app is missing.
- echo "$missingApps" 1>&2;
- fi;
- unset value;
- #===END Display Missing Apps===
+# Location
- #===BEGIN Display Missing Files===
- missingFiles="Missing files:";
- #for key in "${!fileRollCall[@]}"; do echo "DEBUG:$key => ${fileRollCall[$key]}"; done
- for key in "${!fileRollCall[@]}"; do
- value="${fileRollCall[$key]}";
- if [ "$value" = "false" ]; then
- #echo "DEBUG:Missing files: $key => $value";
- missingFiles="$missingFiles""$key ";
- fileMissing="true";
- fi;
- done;
- if [ "$fileMissing" = "true" ]; then # Only indicate if an app is missing.
- echo "$missingFiles" 1>&2;
- fi;
- unset value;
- #===END Display Missing Files===
-
- #===BEGIN Display Missing Directories===
- missingDirs="Missing dirs:";
- #for key in "${!dirRollCall[@]}"; do echo "DEBUG:$key => ${dirRollCall[$key]}"; done
- for key in "${!dirRollCall[@]}"; do
- value="${dirRollCall[$key]}";
- if [ "$value" = "false" ]; then
- #echo "DEBUG:Missing dirs: $key => $value";
- missingDirs="$missingDirs""$key ";
- dirMissing="true";
- fi;
- done;
- if [ "$dirMissing" = "true" ]; then # Only indicate if an dir is missing.
- echo "$missingDirs" 1>&2;
- fi;
- unset value;
- #===END Display Missing Directories===
-
- #==END Display errors==
-} # Display missing apps, files, dirs
-main() {
- # Note: Use '&' to run scripts and immediately detach them.
-
- # Temperature
-
- # Pressure
-
- # Location
-
- # Photograph
- photo_script_path="$nfg_exec_dir"/update_temp_photograph.sh;
- if checkfile "$photo_script_path"; then
- timeout "$length_day_s"s /bin/bash "$photo_script_path" &
- else
- yell "ERROR:Not found:$photo_script_path";
- fi;
- displayMissing;
-} # main program
-
-#===END Declare local script functions===
-#==END Define script parameters==
-
-main "$@";
+# Photograph
+photo_script_path="$nfg_exec_dir"/update_temp_photograph.sh;
+camera_name="DC1";
+timeout "$length_day_s"s /bin/bash "$photo_script_path" "$camera_name" &